from lib.obter_configuracoes import obter_configuracoes
import sys
from lib.echo import echo
from lib.executar_validacoes_servidor_linux import executar_validacoes_servidor_linux
from lib.ClienteLinux import obter_cliente_linux



arquivo_configuracao = None if len(sys.argv) < 2 else sys.argv[1]
diretorio_scripts_implantacao = r'c:\microuniversoWeb\scriptsImplantacao' if len(sys.argv) < 3 else sys.argv[2]

configuracoes = obter_configuracoes(arquivo_configuracao)

if not configuracoes["acessos"]["servidorLinux"]["configurar"]:
    echo("Dados do servidor linux nao informados. Página Inicial nao sera configurada")
    exit(0)

if not configuracoes["paginaInicial"]["configurar"]:
    echo("Configuracao da Página Inicial desativada via configuracao")
    exit(0)


mensagem_erro = executar_validacoes_servidor_linux(arquivo_configuracao, diretorio_scripts_implantacao)    

if mensagem_erro:
    echo(mensagem_erro, "error")
    exit(1)

cliente_linux = obter_cliente_linux(arquivo_configuracao)

usuario = configuracoes['acessos']['servidorLinux']['usuario']

if cliente_linux.executar_comando(f"test ! -d /home/{usuario}/paginainicial", disparar_excecao_se_retorno_nao_zero=False).codigo_retorno == 0:
    cliente_linux.executar_comando(f'mkdir /home/{usuario}/paginainicial')

cliente_linux.copiar_arquivo(fr'{diretorio_scripts_implantacao}\paginaInicial\docker-compose-pagina-inicial.yml' , f'/home/{usuario}/paginainicial/docker-compose.yml')

url_central_de_cadastros = "{protocolo}://{host}:{porta}".format(
    protocolo="https" if configuracoes["centralDeCadastros"]["https"] else "http",
    host=configuracoes["enderecos"]["ipHost"],
    porta=configuracoes["centralDeCadastros"]["porta"]
)

url_vendas = "{protocolo}://{host}:{porta}".format(
    protocolo="https" if configuracoes["servicos"]["orcamentoWeb"]["configurarHttps"] else "http",
    porta=configuracoes["servicos"]["orcamentoWeb"]["portaHttps"] if configuracoes["servicos"]["orcamentoWeb"]["configurarHttps"] else configuracoes["servicos"]["orcamentoWeb"]["porta"],
    host=configuracoes["enderecos"]["ipHost"]
)

url_seguranca = "{protocolo}://{host}:{porta}".format(
    protocolo="https" if configuracoes["servicos"]["segurancaWeb"]["configurarHttps"] else "http",
    porta=configuracoes["servicos"]["segurancaWeb"]["portaHttps"] if configuracoes["servicos"]["segurancaWeb"]["configurarHttps"] else configuracoes["servicos"]["segurancaWeb"]["porta"],
    host=configuracoes["enderecos"]["ipHost"],
)

url_ordem_de_compra = "{protocolo}://{host}:{porta}".format(

    protocolo="http",
    host=configuracoes["enderecos"]["ipHost"],
    porta=configuracoes["servicos"]["ordemDeCompra"]["porta"]
)

url_financeiro = "{protocolo}://{host}:{porta}".format(
    protocolo="http",
    host=configuracoes["enderecos"]["ipHost"],
    porta=configuracoes["servicos"]["financeiro"]["porta"]
)

url_liberacao_de_pendencias = "{protocolo}://{host}:{porta}".format(
    protocolo="http",
    host=configuracoes["enderecos"]["ipHost"],
    porta=configuracoes["servicos"]["liberarPendencia"]["porta"]
)

url_carrinho_de_compras = "{protocolo}://{host}:{porta}".format(
    protocolo="http",
    host=configuracoes["enderecos"]["ipHost"],
    porta=configuracoes["servicos"]["carrinhoDeCompra"]["porta"]
)

url_paineis_gerencias = "{link}".format(
    link=configuracoes["paginaInicial"]["linkPainelGerencial"]
)


id_cliente_mapa_utilizacao = configuracoes["paginaInicial"]["idMapaDeUtilizacao"]



versao = "latest"
usuario_registro_docker = configuracoes["acessos"]["registroDocker"]["usuario"]
senha_registro_docker = configuracoes["acessos"]["registroDocker"]["senha"]

cliente_linux.executar_comando(fr'docker login gitlab.microuniverso.com.br:5050 -u {usuario_registro_docker} -p {senha_registro_docker}', disparar_excecao_se_retorno_nao_zero=False)

cliente_linux.executar_comando(fr"sed -i 's,\$VERSAO,{versao},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_CENTRAL_CADASTRO,{url_central_de_cadastros},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_VENDAS,{url_vendas},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_SEGURANCA,{url_seguranca},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_ORDEM_COMPRA,{url_ordem_de_compra},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_FINANCEIRO,{url_financeiro},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_LIBERACAO_PENDENCIA,{url_liberacao_de_pendencias},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_CARRINHO_COMPRA,{url_carrinho_de_compras},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$URL_PAINEIS_GERENCIAIS,{url_paineis_gerencias},g' /home/{usuario}/paginainicial/docker-compose.yml")
cliente_linux.executar_comando(fr"sed -i 's,\$ID_CLIENTE_MAPA_UTILIZACAO,{id_cliente_mapa_utilizacao},g' /home/{usuario}/paginainicial/docker-compose.yml")

cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/paginainicial/docker-compose.yml down')    
cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/paginainicial/docker-compose.yml pull')    
cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/paginainicial/docker-compose.yml up -d')    

exit(0)